program install_roll;
uses app,Objects, Drivers, Memory, Views, Menus, Dialogs, StdDlg, MsgBox;
const cminstall= 100;
type PInstall=^TInstall;
     TInstall=object(TApplication)
                constructor init;
                procedure initmenubar; virtual;
                procedure handleevent(var event:tevent); virtual;
                function installdialog:word;
                procedure infowindow;
              end;
     TDialogData=record
                   Karte,Sound,Eingabe:word;
                 end;
var Dialogdata:Tdialogdata;

procedure Tinstall.infowindow;
var d:Pdialog;
    r:trect;
    control:word;
begin
  r.assign(0,0,54,13);
  d:=new(pdialog,init(r,'Information'));
  with d^ do begin
    Options := Options or ofCentered;
    R.Assign(18,2,52,3);
    Insert(New(PStaticText, Init(R,'Jump ''n'' Roll')));
    R.Assign(7,4,52,5);
    Insert(New(PStaticText, Init(R,'(c) 1991 Mathias & Florian Schreck')));
    R.Assign(4,6,52,7);
    Insert(New(PStaticText, Init(R,'Jump ''n'' Roll funktioniert nur mit VGA Karte !')));
    R.Assign(4,8,52,9);
    Insert(New(PStaticText, Init(R,'Rufen Sie Jump ''n'' Roll mit "Jump<" auf !')));
    R.Assign(20, 10, 30, 12);
    Insert(New(PButton, Init(R, '~O~K', cmOk, bfDefault)));
  end;
  if ValidView(D) <> nil then
  begin
    control:=Desktop^.ExecView(D);
    Dispose(D, Done);
  end;
end;

function Tinstall.installdialog:word;
var
  D: PDialog;
  Control: word;
  R: TRect;
  bruce:PView;
begin
  R.Assign(0, 0, 54, 19);
  D := New(PDialog, Init(R, 'Install'));
  with D^ do
  begin
    Options := Options or ofCentered;
    R.Assign(3,2,52,3);
    Insert(New(PStaticText, Init(R,'Jump ''n'' Roll funktioniert nur mit VGA Karte !')));
    R.assign(2,5,52,7);
    bruce:=new(PRadioButtons,init(r,
      newsitem('Sound ~B~laster',
      newsitem('~G~ame Blaster',
      newsitem('Ad~L~ib',
      newsitem('~I~nterner Lautsprecher',nil))))));
    insert(bruce);
    R.Assign(2,4,52,5);
    Insert(New(PLabel, Init(R,'Welche Soundkarte hast Du ?',bruce)));
    R.assign(2,9,52,12);
    bruce:=new(PCheckBoxes,init(r,
      newsitem('M~u~sik         (Sound Blaster / AdLib)',
      newsitem('~F~ahrgerusche (Sound Blaster / Game Blaster)',
      newsitem('~S~prache       (Sound Blaster)',nil)))));
    insert(bruce);
    R.Assign(2,8,52,9);
    Insert(New(PLabel, Init(R,'Welche Sound-Effekte willst Du ?',bruce)));
    R.assign(2,14,52,15);
    bruce:=new(PRadioButtons,init(r,
      newsitem('~J~oystick',
      newsitem('~M~aus',
      newsitem('~T~astatur',nil)))));
    insert(bruce);
    R.Assign(2,13,52,14);
    Insert(New(PLabel, Init(R,'Welches Eingabegert willst Du benutzen ?',bruce)));
    R.Assign(2, 16, 12, 18);
    Insert(New(PButton, Init(R, '~O~K', cmOk, bfDefault)));
    R.Assign(16 ,16, 28, 18);
    Insert(New(PButton, Init(R, 'C~a~ncel', cmCancel, bfNormal)));
  end;
  if ValidView(D) <> nil then
  begin
    d^.setdata(dialogdata);
    control:=Desktop^.ExecView(D);
    if control<>cmcancel then d^.getdata(dialogdata);
    Dispose(D, Done);
  end;
  installdialog:=control;
end;

procedure TInstall.initmenubar;
var r:TRect;
begin
  getextent(r);
  r.b.y:=succ(r.a.y);
  menubar:=new(PMenubar, Init(r,
   newmenu(
    newsubmenu('~J~ump ''n'' Roll',hcNoContext,
       newmenu(newitem('~I~nstall','',kbnokey,cminstall,hcnocontext,
       newitem('~Q~uit','',kbALTx,cmquit,hcnocontext,nil)
       ))
    ,nil))));
end;

procedure tinstall.handleevent(var event:tevent);
begin
  TApplication.HandleEvent(Event);
  case Event.What of
    evCommand:
      begin
        case Event.Command of
          cminstall:if installdialog<>cmcancel then begin
                      ClearEvent(Event);
                      endmodal(cmquit);
                    end;
        else
          Exit;
        end;
        ClearEvent(Event);
      end;
  end;
end;

constructor TInstall.init;
begin
  TApplication.init;
  with Dialogdata do begin
    karte:=0;sound:=1+2+4;eingabe:=0;
  end;
end;

procedure machebatch;
var t:text;
begin
  assign(t,'JUMP.BAT');
  rewrite(t);
  with DialogData do begin
    writeln(t,'@ECHO OFF');
    if (((sound and 1)>0) and ((karte=0) or (karte=2))) then writeln(t,'SOUND b9000');
    write(t,'TITEL');
    if (((sound and 1)>0) and ((karte=0) or (karte=2))) then writeln(t,' THUNDER2') else writeln(t);
    write(t,'ROLL STAGE0 ');
    case karte of
      0:write(t,'S');
      1:write(t,'G');
      2:write(t,'A');
      3:write(t,'I');
    end;
    write(t,' ');
    if (sound and 4)>0 then write(t,'S ') else write(t,'X ');
    if (sound and 2)>0 then write(t,'F ') else write(t,'X ');
    if (sound and 1)>0 then write(t,'M ') else write(t,'X ');
    case eingabe of
      0:writeln(t,'J');
      1:writeln(t,'M');
      2:writeln(t,'T');
    end;
  end;
  close(t);
end;

var Install:TInstall;
begin
  install.init;
  if Install.installdialog<>cmcancel then begin
    machebatch;
    install.infowindow;
  end;
  install.done;
end.