unit sbunit;
interface
uses sbdrv;
const on=1;
      off=0;
var status:word;
    installed:word;
function sbversion:word;
procedure sbioaddress(address:word);
procedure sbinterrupt(inter:word);
function sbinit:word;
procedure sbspeaker(onoff:byte);
procedure sbsetstatus(statusword:pointer);
procedure sboutput(address:pointer);
procedure sbinput(rate:word;length:longint;address:pointer);
procedure sbstop;
procedure sbuninstall;
function sbpause:word;
function sbcontinue:word;
function sbbreakout(how:word):word;
procedure sbsetuserfunction(address:pointer);
function sbgeterrormessage(fehler:word):string;

implementation
var oldexit:pointer;

function sbversion:word;
begin
  inline($BB/$00/$00);    {mov BX,00}
  voicecall;
  inline($89/$86/sbversion);
end;

procedure sbioaddress(address:word);
begin
  inline($8B/$86/address);  {mov ax,[bp+^address] = mov ax,address}
  inline($BB/$01/$00);          {mov bx,1}
  voicecall;
end;

procedure sbinterrupt(inter:word);
begin
  inline($8B/$86/inter);  {mov ax,[bp+^interrupt] = mov ax,interrupt}
  inline($BB/$02/$00);            {mov bx,2}
  voicecall;
end;

function sbinit:word;
begin
  inline($BB/$03/$00);    {mov BX,00}
  voicecall;
  inline($89/$86/sbinit);
end;

procedure sbspeaker(onoff:byte);
begin
  inline($8A/$86/onoff);  {mov al,[bp+^onoff] = mov al,onoff}
  inline($BB/$04/$00);            {mov bx,4}
  voicecall;
end;

procedure sbsetstatus(statusword:pointer);
begin
  inline($8b/$BE/statusword);  {mov DI,[BP+^statusword] = mov di,statusword}
  inline($8E/$86/statusword+2);{mov es,[BP+^statusword+2] = mov es,statusword+2}
  inline($BB/$05/$00);            {mov bx,4}
  voicecall;
end;

procedure sboutput(address:pointer);
begin
  inline($8b/$BE/address);  {mov DI,[BP+^statusword] = mov di,statusword}
  inline($8E/$86/address+2);{mov ES,[BP+^statusword+2] = mov ES,statusword+2}
  inline($BB/$06/$00);            {mov bx,4}
  voicecall;
end;

procedure sbinput(rate:word;length:longint;address:pointer);
begin
  inline($8b/$BE/address);  {mov DI,[BP+^statusword] = mov di,statusword}
  inline($8E/$86/address+2);{mov ES,[BP+^statusword+2] = mov ES,statusword+2}
  inline($8B/$86/rate);{mov ax,[bp+^interrupt] = mov ax,interrupt}
  inline($8b/$8E/length);  {mov CX,[BP+^statusword] = mov CX,statusword}
  inline($8B/$96/length+2);{mov DX,[BP+^statusword+2] = mov DX,statusword+2}
  inline($BB/$07/$00);            {mov bx,4}
  voicecall;
end;

procedure sbstop;
begin
  inline($BB/$08/$00);    {mov BX,00}
  voicecall;
end;

procedure sbuninstall;
begin
  inline($BB/$09/$00);    {mov BX,00}
  voicecall;
end;

function sbpause:word;
begin
  inline($BB/$0A/$00);  {mov BX,00}
  voicecall;
  inline($89/$86/sbpause);
end;

function sbcontinue:word;
begin
  inline($BB/$0B/$00);  {mov BX,00}
  voicecall;
  inline($89/$86/sbcontinue);
end;

function sbbreakout(how:word):word;
begin
  inline($8B/$86/how);{mov ax,[bp+^interrupt] = mov ax,interrupt}
  inline($BB/$0C/$00);  {mov BX,00}
  voicecall;
  inline($89/$86/sbbreakout);
end;

procedure sbsetuserfunction(address:pointer);
begin
  inline($8B/$86/address);{mov ax,[bp+^interrupt] = mov ax,interrupt}
  inline($8B/$96/address+2);{mov DX,[BP+^statusword+2] = mov DX,statusword+2}
  inline($BB/$0D/$00);            {mov bx,4}
  voicecall;
end;

function sbgeterrormessage(fehler:word):string;
begin
  case fehler of
    0:sbgeterrormessage:='successfully initialized';
    1:sbgeterrormessage:='Voice card fails';
    2:sbgeterrormessage:='I/O read/write fails';
    3:sbgeterrormessage:='interrupt for DMA fails';
    else sbgeterrormessage:='unknown error';
  end;
end;

{$F+}
procedure myexit;
begin
  sbstop;
  sbuninstall;
  exitproc:=oldexit;
end;
{$F-}

begin
  oldexit:=exitproc;
  exitproc:=@myexit;
  installed:=sbinit;
  sbsetstatus(@status);
end.