unit adlib;
interface
uses dos;
const an=1;
      aus=0;
      melodisch=1;
      schlagzeug=0;
const aderror:byte=1;
function advorhanden:boolean;
procedure adinit;
procedure adsetstart(zaler,nenner:integer);
procedure adsetstatus(stat:integer);
function adgetstatus:integer;
procedure adclear;
procedure adsetmodus(modu:integer);
function adgetmodus:integer;
procedure adsetvolume(volzal,volnen,verzzal,verznen:integer);
procedure adsettempo(temzal,temnen,verzzal,verznen:integer);
procedure adsettranspos(tr:integer);
function adgettranspos:integer;
procedure adsetstimme(stim:integer);
function adgetstimme:integer;
procedure adrelton(hohe,dauzal,daunen,verzal,vernen:integer);
procedure adton(hohe,zaler,nenner:integer);
procedure adsetpitch(delta,stizal,stinen,verzal,vernen:integer);
procedure adsetticks(tick:integer);
procedure adtonan(stimme,hohe:integer);
procedure adtonaus(stimme:integer);
function adlibcall(funktionscode,s1,s2,s3,s4,s5:integer):integer;
procedure SetInstr(var FunkCode,Klang:Integer;s2,s3:Integer);

implementation
type Tvec=record case boolean of
            true:(p:pointer);
            false:(ofs,seg:word);
          end;
     Tchararray=array[1..19] of char;
     Pchararray=^TChararray;
const kennung:Tchararray='SOUND-DRIVER-AD-LIB';
function advorhanden:boolean;
var vec:tvec;
    gleich:boolean;
    n:byte;
begin
  getintvec(101,vec.p);
  dec(vec.seg,2);
  inc(vec.ofs,10);
  if vec.ofs>15 then begin
    dec(vec.seg);
    inc(vec.ofs,16);
  end;
  gleich:=true;
  for n:=1 to 19 do begin
    gleich:=gleich and (Pchararray(vec.p)^[n]=kennung[n]);
  end;
  advorhanden:=gleich;
end;

function adlibcall(funktionscode,s1,s2,s3,s4,s5:integer):integer;
var hilf:integer;
begin
  asm
    mov      si,funktionscode
    mov      bx,s5
    push     bx
    mov      bx,s4
    push     bx
    mov      bx,s3
    push     bx
    mov      bx,s2
    push     bx
    mov      bx,s1
    push     bx
    push     ss
    pop      es
    mov      bx,sp
    int      101
    mov      hilf,ax
  end;
  adlibcall:=hilf;
end;

procedure SetInstr(var FunkCode,Klang:Integer;s2,s3:Integer);
begin
  asm
    push ds
    les di,funkcode
    mov si,es:[di]
    mov bx,s3
    push bx
    cmp si,16
    jne @timbre
    mov bx,s2
    push bx
    les di,klang
    push es
    push di
    jmp @OK
@timbre:
    les di,klang
    push es
    push di
    mov bx,s2
    push bx
@ok:
    push ss
    pop es
    mov bx,sp
    int 101

{    mov sp,bp
    les di,funkcode
    mov es:[di],ax}

    pop ds
  end;
end;

procedure adinit;
begin
  asm
    mov      si,0
    int      101
  end;
end;

procedure adsetstart(zaler,nenner:integer);
begin
  adlibcall(2,zaler,nenner,0,0,0);
end;

procedure adsetstatus(stat:integer);
begin
  adlibcall(3,stat,0,0,0,0);
end;

function adgetstatus;
var h:integer;
begin
  asm
    mov      si,4
    int      101
    mov      h,ax
  end;
  adgetstatus:=h;
end;

procedure adclear;
begin
  asm
    mov      si,5
    int      101
  end;
end;

procedure adsetmodus(modu:integer);
begin
  adlibcall(6,modu,0,0,0,0);
end;

function adgetmodus;
var h:integer;
begin
  asm
    mov      si,7
    int      101
    mov      h,ax
  end;
  adgetmodus:=h;
end;

procedure adsetvolume(volzal,volnen,verzzal,verznen:integer);
begin
  aderror:=adlibcall(8,volzal,volnen,verzzal,verznen,0);
end;

procedure adsettempo(temzal,temnen,verzzal,verznen:integer);
begin
  aderror:=adlibcall(9,temzal,temnen,verzzal,verznen,0);
end;

procedure adsettranspos(tr:integer);
begin
  adlibcall(10,tr,0,0,0,0);
end;

function adgettranspos;
var h:integer;
begin
  asm
    mov      si,11
    int      101
    mov      h,ax
  end;
  adgettranspos:=h;
end;

procedure adsetstimme(stim:integer);
begin
  adlibcall(12,stim,0,0,0,0);
end;

function adgetstimme;
var h:integer;
begin
  asm
    mov      si,13
    int      101
    mov      h,ax
  end;
  adgetstimme:=h;
end;

procedure adrelton(hohe,dauzal,daunen,verzal,vernen:integer);
begin
  aderror:=adlibcall(14,hohe,dauzal,daunen,verzal,vernen);
end;

procedure adton(hohe,zaler,nenner:integer);
begin
  aderror:=adlibcall(15,hohe,zaler,nenner,0,0);
end;

procedure adsetpitch(delta,stizal,stinen,verzal,vernen:integer);
begin
  adlibcall(17,delta,stizal,stinen,verzal,vernen);
end;

procedure adsetticks(tick:integer);
begin
  adlibcall(18,tick,0,0,0,0);
end;

procedure adtonan(stimme,hohe:integer);
begin
  adlibcall(19,stimme,hohe,0,0,0);
end;

procedure adtonaus(stimme:integer);
begin
  adlibcall(20,stimme,0,0,0,0);
end;

end.