program getfont8x8;
uses crt,vga;
type Tzeichen=array[0..8,0..8] of byte;
     Tfont8x8=array[0..255] of Tzeichen;
var font:Tfont8x8;
    pal:PPalette;

procedure getfont;
var n,x,y:byte;
begin
  for n:=0 to 255 do begin
    gotoxy(1,1);
    write(chr(n));
    for y:=0 to 7 do for x:=0 to 7 do font[n,x,y]:=getpixel(x,y);
  end;
end;

procedure verschoenerefont;
const tabelle:array[0..8] of byte=(10,8,7,6,5,6,7,8,10);
var zeichen:tzeichen;
    x,y:word;
    x2,y2,n:byte;
begin
  for n:=0 to 255 do begin
    fillchar(zeichen,sizeof(zeichen),0);
    for x2:=0 to 7 do for y2:=0 to 7 do if font[n,x2,y2]<>0 then zeichen[x2,y2]:=1;
    for x2:=0 to 7 do for y2:=0 to 7 do
     if font[n,x2,y2]<>0 then begin
       zeichen[succ(x2),succ(y2)]:=tabelle[y2];
     end;
    font[n]:=zeichen;
  end;
end;

procedure ausgabefont;
var x,y:word;
    x2,y2,n:byte;
begin
  for n:=0 to 255 do begin
    x:=(n mod 20)*16;
    y:=(n div 20)*16;
    for x2:=0 to 7 do for y2:=0 to 7 do
     if font[n,x2,y2]<>0 then plot(x+x2,y+y2,font[n,x2,y2]);
  end;
end;

procedure initpalette;
var n:byte;
begin
  for n:=0 to 10 do begin
    pal^[n,0]:=round(n*6.3);
    pal^[n,1]:=round(n*6.3);
    pal^[n,2]:=round(n*6.3);
  end;
  farbblock(0,11,pal);
end;

procedure sicherefont;
const tabel:array[0..10] of byte=(0,2,3,4,5,6,7,8,9,10,1);
var n,x,y:byte;
    f:text;
begin
  assign(f,'font.pas');
  rewrite(f);
  writeln(f,'const font:array[33..90,0..8,0..7] of byte =(');
  for n:=33 to 90 do begin
    write(f,'(');
    for y:=0 to 8 do begin
      write(f,'(');
      for x:=0 to 7 do begin
        write(f,tabel[font[n,x,y]]);
        if x<>7 then write(f,',');
      end;
      write(f,')');
      if y<>8 then writeln(f,',') else writeln(f);
    end;
    writeln(f,'),');
  end;
  writeln(f,')');
  close(f);
end;

begin
  new(pal);
  directvideo:=false;
  videomodus($13);
  initpalette;
  map($f);
  fillchar(mem[$a000:0],64000,3);
  getfont;
  verschoenerefont;
  ausgabefont;
  sicherefont;
  readln;
end.