program jump_n_roll;
uses crt,dos,vga,joystick,playunit;
const play:array[0..18] of byte=(24,25,27,29,32,35,39,43,47,52,58,65,72,82,93,
                                 107,125,148,180);
const play2:array[0..49] of byte=(24,25,27,29,32,35,39,43,47,52,55,58,62,65,69,
                                 72,75,77,80,82,84,86,89,91,93,95,98,100,102,105,107,110,113,
                                 116,119,122,125,130,134,139,143,148,154,
                                 161,167,174,180,186,193,199);
const delta:array[0..18] of byte=  (1,1,1,1,1,1,1,1,1,2,2,2,4,5,6,6,5,5,4);
{const play2:array[0..38] of byte=(24,25,27,29,32,35,39,43,47,52,58,61,65,68,
                                72,77,82,88,93,100,107,113,119,125,131,137,142,
                                  148,153,159,164,169,175,180,185,190,195,199);}
      aktpos:word=1;
      zustand:byte=0;
      gesch:byte=1;
      pos:byte=2;
      xpos:integer=159;
      ypos:integer=164;
      altx:integer=159;
      alty:integer=164;
      tod:boolean=false;
      jump:byte=0;
      kugelsicht_:boolean=false;
      anderung:integer=0;
type TBahn=array[0..12000,0..4] of char;
     TFarbwert=array[0..2] of byte;
     TFarbe=array[chr(0)..chr(255)] of TFarbwert;
     kugelbuftyp=array[-2..2,-2..2] of byte;
var Bahn:TBahn;
    BahnLange:word;
    pal:PPalette;
    Farbe:TFarbe;
    kugelbuf:kugelbuftyp;
    midpos:integer;

  procedure kugelsetzen(x,y:word);
  var n,n2:shortint;
  begin
    for n:=-2 to 2 do
    for n2:=-2 to 2 do begin
      kugelbuf[n,n2]:=getpixel(x+n,y+n2);
      plot(x+n,y+n2,254);
    end;
  end;

  procedure kugelloschen(x,y:word);
  var n,n2:shortint;
  begin
    for n:=-2 to 2 do for n2:=-2 to 2 do plot(x+n,y+n2,kugelbuf[n,n2]);
  end;

  procedure kugelunsicht;
  begin
    if kugelsicht_ then begin
      kugelloschen(altx,alty);
      kugelsicht_:=false;
    end;
  end;

  procedure kugelsicht;
  begin
    if not kugelsicht_ then begin
      kugelsetzen(xpos,ypos);
      kugelsicht_:=true;
      altx:=xpos;alty:=ypos;
    end;
  end;

  procedure bewegekugel;
  begin
    if kugelsicht_ then begin
      kugelloschen(altx,alty);
      kugelsetzen(xpos,ypos);
    end;
    altx:=xpos; alty:=ypos;
  end;

procedure lesebahn(name:namestr);
var f:text;
    buf:string[5];
    n:byte;
begin
  assign(f,name+'.jmp');
  reset(f);
  BahnLange:=0;
  while (not eof(f)) do begin
    readln(f,buf);
    while length(buf)<5 do buf:=buf+' ';
    for n:=1 to 5 do bahn[Bahnlange,pred(n)]:=buf[n];
    inc(BahnLange);
  end;
  close(f);
end;

{
procedure playground;
const ay=9*25;ax=-5*25;
var n:word;
    f:text;

function proj(px:word):word;
begin
  proj:=(longint(ay)*longint(px)) div (longint(px)-longint(ax));
end;

procedure line(y:word);
var x:word;
begin
  for x:=0 to 319 do plot(x,y,1);
end;

begin
  for n:=0 to 30 do line(199-proj(((n*25+12) div 4)));
  for n:=0 to 5 do rgb_line(155+n,24,50+n*44,199,2+n);
  assign(f,'play.pas');
  rewrite(f);
  for n:=30 downto 0 do writeln(f,199-proj(((n*25+12) div 4)));
  close(f);
end;
}
{
procedure playground;
var n:word;

procedure line(y:word;c:byte);
var x:word;
begin
  for x:=0 to 319 do plot(x,y,c);
end;

begin
  for n:=0 to 49 do line(play2[n],2);
  for n:=0 to 18 do line(play[n],1);
  for n:=0 to 5 do rgb_line(155+n,24,50+n*44,199,2+n);
end;
}
procedure playground;
type TLinie=array[24..199] of byte;
     TLinien=array[0..5] of TLinie;
var n:byte;
    x,y:word;
    Linien:TLinien;

procedure line(y,xa,xe:word;c:byte);
var x:word;
begin
  for x:=xa+50 to xe+50 do plot(x,y,c);
end;

procedure calc_line(x1,y1,x2,y2:integer;var Linie:TLinie);
type intf=record case boolean of
            true:(fix:longint);
            false:(f:word;i:integer);
          end;
var dyddx,dxddy,sy,sx:intf; dy,dx,h:integer;
begin
  dy:=abs(y2-y1); dx:=abs(x2-x1);
  if (dx>dy) then begin
    if x2<x1 then begin h:=x1; x1:=x2; x2:=h; h:=y1; y1:=y2; y2:=h; end;
    Linie[y1]:=x1;
    if dx<>0 then begin
      sy.i:=y1; sy.f:=$8000;
      dyddx.i:=y2-y1; dyddx.f:=0;dyddx.fix:=dyddx.fix div dx;
      while x1<x2-1 do begin
        inc(x1); inc(sy.fix,dyddx.fix); linie[sy.i]:=x1;
      end;
      linie[y2]:=x2;
    end;
  end else begin
    if y2<y1 then begin h:=x1; x1:=x2; x2:=h; h:=y1; y1:=y2; y2:=h; end;
    linie[y1]:=x1;
    if dy<>0 then begin
      sx.i:=x1; sx.f:=$8000;
      dxddy.i:=x2-x1; dxddy.f:=0;dxddy.fix:=dxddy.fix div dy;
      while y1<y2-1 do begin
        inc(y1); inc(sx.fix,dxddy.fix);
        linie[y1]:=sx.i;
      end;
      linie[y2]:=x2;
    end;
  end;
end;

begin
  for n:=0 to 5 do calc_line(105+n,24,n*44,199,Linien[n]);
  for n:=0 to 48 do
  for x:=play2[n] to pred(play2[succ(n)]) do begin
    line(x,linien[0,x],linien[1,x],n);
    line(x,linien[1,x],linien[2,x],n+50);
    line(x,linien[2,x],linien[3,x],n+2*50);
    line(x,linien[3,x],linien[4,x],n+3*50);
    line(x,linien[4,x],linien[5,x],n+4*50);
  end;
end;

procedure black;
begin
  fillchar(pal^,sizeof(pal^),#0);
  waitsync;
  farbblock(0,255,pal);
end;

procedure shadein;
var aktpal:TPalette;
    n:word;
    c,r:byte;
begin
  for n:=1 to 32 do begin
    for c:=0 to 255 do for r:=0 to 2 do aktpal[c,r]:=byte(word(pal^[c,r])*word(n) div 32);
    waitsync;
    farbblock(0,255,@aktpal);
  end;
end;

procedure shadeout;
var aktpal:TPalette;
    n:word;
    c,r:byte;
begin
  for n:=32 downto 0 do begin
    for c:=0 to 255 do for r:=0 to 2 do aktpal[c,r]:=byte(word(pal^[c,r])*word(n) div 32);
    waitsync;
    farbblock(0,255,@aktpal);
  end;
end;

procedure initpalette;
var n,i,k,akt:byte;
begin
  akt:=0;
  for n:=18 downto 0 do begin
    for i:=1 to delta[18-n] do begin
      for k:=0 to 4 do begin
        TFarbwert(pal^[akt+k*50]):=farbe[bahn[n,k]];
      end;
      inc(akt);
    end;
  end;
  for n:=50*5+1 to 255 do for k:=0 to 2 do pal^[n,k]:=0;
  pal^[254,0]:=64;pal^[254,2]:=64;pal^[254,1]:=1;
end;

procedure spiel;

  procedure bewegebahn;
  var tpal:PPalette;
      m:byte;

    procedure verschiebe(anf:byte);
    var n:byte;
    begin
      for n:=0 to 4 do begin
        move(pal^[anf+n*50],pal^[succ(anf+n*50)],(49-Anf)*3);
      end;
    end;

    procedure schieben;
    var n:byte;
    begin
      case zustand of
        0:begin
            verschiebe(0);
            for n:=0 to 4 do begin
              TFArbWert(pal^[n*50]):=farbe[bahn[aktpos+19,n]];
            end;
            if jump>0 then begin dec(jump); inc(ypos,10); end;
            inc(aktpos);
          end;
        1:verschiebe( 8);
        2:verschiebe(14);
        3:verschiebe(14);
        4:verschiebe(18);
        5:verschiebe(23);
      end;
      inc(zustand);
      if zustand=6 then zustand:=0;
    end;

  begin
    for m:=1 to gesch do schieben;
    waitsync;
    farbblock(0,50*5,pal);
  end;

  procedure bewegekug;
  var richtung:integer;
  begin
    if bahn[succ(aktpos),pos]<>'' then begin
      richtung:=paddle(0)-midpos;
      if bahn[succ(aktpos),pos]='l' then richtung:=-richtung;
      anderung:=anderung+richtung div 30;
      if anderung<-300 then anderung:=-300;
      if anderung>300 then anderung:=300;
      xpos:=xpos+anderung div 50;
      if xpos<75 then begin xpos:=75;anderung:=round(-anderung / 1.8); end;
      if xpos>239 then begin xpos:=239;anderung:=round(-anderung / 1.8); end;
      bewegekugel;
      pos:=(xpos-75) div 33;
    end;
  end;

  procedure auswerten;
  begin
    case bahn[succ(aktpos),pos] of
      ' ':tod:=jump=0;
      'g':gesch:=3;
      'r':delay(50);
      'b':begin jump:=3;ypos:=134; end;
      else gesch:=1;
    end;
    if switch(0) then begin jump:=3;ypos:=134; end;
  end;

begin
  bewegebahn;
  bewegekug;
  auswerten;
end;

begin
  new(pal);
  Farbe['b',0]:=17;
  Farbe['b',1]:=17;
  Farbe['b',2]:=59;
  Farbe[' ',0]:= 0;
  Farbe[' ',1]:= 0;
  Farbe[' ',2]:= 0;
  Farbe['g',0]:=53;
  Farbe['g',1]:=58;
  Farbe['g',2]:= 6;
  Farbe['',0]:= 9;
  Farbe['',1]:=46;
  Farbe['',2]:= 6;
  Farbe['r',0]:=53;
  Farbe['r',1]:=17;
  Farbe['r',2]:= 6;
  Farbe['l',0]:=59;
  Farbe['l',1]:=11;
  Farbe['l',2]:=49;
  Farbe['h',0]:=55;
  Farbe['h',1]:=41;
  Farbe['h',2]:= 4;
  Farbe['d',0]:=45;
  Farbe['d',1]:=28;
  Farbe['d',2]:= 6;
  Farbe['a',0]:=32;
  Farbe['a',1]:=32;
  Farbe['a',2]:=32;
  Farbe['w',0]:=63;
  Farbe['w',1]:=63;
  Farbe['w',2]:=63;
  lesebahn('test');
  initjoysticktext(0);
  midpos:=maxpos[0,0,0]+((maxpos[0,0,1]-maxpos[0,0,0]) div 2);
  videomodus($13);
  map($F);
  fillchar(mem[$A000:0],$FFFF,$FF);
  overscan(255);
  black;
  repeat
    aktpos:=1;
    zustand:=0;
    gesch:=1;
    pos:=2;
    xpos:=159;
    ypos:=164;
    altx:=159;
    alty:=164;
    tod:=false;
    jump:=0;
    kugelsicht_:=false;
    anderung:=0;
    playground;
    initpalette;
    kugelsicht;
    spiele('go');
    shadein;
    repeat
      spiel;
    until (aktpos>=Bahnlange-20) or keypressed or tod;
    if tod then spiele('tod') else if not keypressed then spiele('hit');
    shadeout;
  until keypressed;
end.